--
-- Rundumleuchte
-- Specialization for beacon-lights
-- Spezialisierung fr Rundumleuchten
-- @author  Sven777b
-- 
-- Modifikationen erst nach Rcksprache
--

RT = {};

function RT.prerequisitesPresent(specializations)
    return true;
end;

function RT:load(xmlFile)
		print("specialization rotazione by MoonDraon");
		local i = 0;
		self.rotazione = {};
    self.rotazioneAn = false;
		while true do
			local RT = {};
			local objname = string.format("vehicle.rotazione.rota(%d)",i);
      local rotnode = getXMLString(xmlFile, objname .. "#rotNode");
      if rotnode == nil then 
      	break;
      end;
      RT = {};
      RT.rotNode = Utils.indexToObject(self.components, rotnode);
      RT.light = Utils.indexToObject(self.components, getXMLString(xmlFile, objname .. "#light"));
      if(RT.rotNode == nil or RT.light == nil) then
      	print("Error: Index ("..rotnode..") zur Rundumleuchte nicht gefunden");
      else
	      RT.speed = Utils.getNoNil(getXMLInt(xmlFile,  objname .. "#rotSpeed"), 1)/1000;
	      RT.source = Utils.indexToObject(self.components, getXMLString(xmlFile, objname .. "#lightsource"));
	      if (RT.source == nil) then
	      	RT.emit = false;
	      else
      		RT.emit = Utils.getNoNil(getXMLBool(xmlFile, objname .. "#emitLight"), true);
      		if not RT.emit then
      			setVisibility(RT.source, false);
      		end;
      	end;
      	table.insert(self.rotazione, RT);
      end;
      i=i+1;
    end;
    self.rotazioneAnz = table.getn(self.rotazione);
end;

function RT:delete()
end;

function RT:mouseEvent(posX, posY, isDown, isUp, button)
end;

function RT:keyEvent(unicode, sym, modifier, isDown)
end;

function RT:update(dt)
	if self.rotazioneAnz > 0 and self:getIsActive() then
    if InputBinding.hasEvent(InputBinding.ROTA) then
    	self.rotazioneAn = not self.rotazioneAn;
      for i=1, self.rotazioneAnz do
        setVisibility(self.rotazione[i].light, self.rotazioneAn);
      end;
    end;
    if self.rotazioneAn then
      for i=1, self.rotazioneAnz do
        rotate(self.rotazione[i].rotNode, 0, dt*self.rotazione[i].speed, 0);
      end;
    end;
  end;
end;

function RT:draw()
    if self.rotazioneAnz > 0 and self:getIsActive() then
    		g_currentMission:addHelpButtonText(g_i18n:getText("rota"), InputBinding.ROTA);
    end;
end;

